Linux Audio

Check our new training course

Linux kernel drivers training

May 6-19, 2025
Register
Loading...
Note: File does not exist in v3.15.
 1ifdef CONFIG_GCC_PLUGINS
 2  __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
 3  PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
 4
 5  SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
 6
 7  gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY)	+= cyc_complexity_plugin.so
 8
 9  gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY)	+= latent_entropy_plugin.so
10  gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY)	+= -DLATENT_ENTROPY_PLUGIN
11  ifdef CONFIG_PAX_LATENT_ENTROPY
12    DISABLE_LATENT_ENTROPY_PLUGIN			+= -fplugin-arg-latent_entropy_plugin-disable
13  endif
14
15  ifdef CONFIG_GCC_PLUGIN_SANCOV
16    ifeq ($(CFLAGS_KCOV),)
17      # It is needed because of the gcc-plugin.sh and gcc version checks.
18      gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV)           += sancov_plugin.so
19
20      ifneq ($(PLUGINCC),)
21        CFLAGS_KCOV := $(SANCOV_PLUGIN)
22      else
23        $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
24      endif
25    endif
26  endif
27
28  GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
29
30  export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR
31  export SANCOV_PLUGIN DISABLE_LATENT_ENTROPY_PLUGIN
32
33  ifneq ($(PLUGINCC),)
34    # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
35    GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
36  endif
37
38  KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
39  GCC_PLUGIN := $(gcc-plugin-y)
40  GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
41endif
42
43# If plugins aren't supported, abort the build before hard-to-read compiler
44# errors start getting spewed by the main build.
45PHONY += gcc-plugins-check
46gcc-plugins-check: FORCE
47ifdef CONFIG_GCC_PLUGINS
48  ifeq ($(PLUGINCC),)
49    ifneq ($(GCC_PLUGINS_CFLAGS),)
50      ifeq ($(call cc-ifversion, -ge, 0405, y), y)
51	$(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
52	@echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
53      else
54	@echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
55      endif
56    endif
57  endif
58endif
59	@:
60
61# Actually do the build, if requested.
62PHONY += gcc-plugins
63gcc-plugins: scripts_basic gcc-plugins-check
64ifdef CONFIG_GCC_PLUGINS
65	$(Q)$(MAKE) $(build)=scripts/gcc-plugins
66endif
67	@: